Package com.emc.d2fs.interfaces

# Interface IVDContentService

All Superinterfaces:
  `ID2fsService`

public interface IVDContentService extends ID2fsService
Virtual Document management services.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `addVDChild(Context context, String vdId, int childIdx, String childId, List<Attribute> attributes)`
  Add child component to a virtual document
  `String`
  `getDialogForOperation(Context context, String parentId, String childId, String operation, List<Attribute> attributes)`
  `Node`
  `getVDContent(Context context, String id, List<Attribute> options)`
  Get tree content of virtual document
  `String`
  `insertInheritedComponent(Context context, String srcVdId, String vdTemplateName, String inheritedComponentId, boolean overrideExistingComponent, List<Attribute> attributes)`
  Inserts an inherited component as child element based on a VD template
  `boolean`
  `moveVDChild(Context context, String srcParentId, String tgtParentId, String moveId, String moveNum, String toNum, List<Attribute> attributes)`
  Move within VD
  `boolean`
  `removeVDChild(Context context, String parentId, int childIdx, List<Attribute> attributes)`
  Remove child VD
  `boolean`
  `replaceVDChild(Context context, String vdocId, int childIndex, String newDocId, List<Attribute> attributes)`
  Replace child VD.
  `boolean`
  `setVDChildBindingVersions(Context context, String parentId, String childIdx, String versionLabel, List<Attribute> attributes)`
  Set binding version for a child components

  ### Methods inherited from interface com.emc.d2fs.interfaces.ID2fsService

  `isRemote, setRemote`

- ## Method Details

  - ### getVDContent

    Node getVDContent(Context context, String id, List<Attribute> options) throws Exception
    Get tree content of virtual document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
      `options` - List of attrbutes
      - vdShowVersion - boolean true to include version information.
      - vdShowNumber - boolean true to include virtual document numbers.
    Returns:
      Node as content
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### addVDChild

    boolean addVDChild(Context context, String vdId, int childIdx, String childId, List<Attribute> attributes) throws Exception
    Add child component to a virtual document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `vdId` - String value of virtual document id
      `childIdx` - integer value of insert index
      `childId` - String value of child document id
      `attributes` - List of attributes
      - confirm - (optional) true to confirm any warnings returned as exceptions.
    Returns:
      true if successfully
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### moveVDChild

    boolean moveVDChild(Context context, String srcParentId, String tgtParentId, String moveId, String moveNum, String toNum, List<Attribute> attributes) throws Exception
    Move within VD
    Parameters:
      `context` - `Context` object containing informations about client/session
      `srcParentId` - Id of the source VD
      `tgtParentId` - Id of the target VD
      `moveId` - Id if the document to be moved
      `moveNum` - Index number of the item to move.
      `toNum` - Index number if the target position.
      `attributes` - List of attributes
      - confirm - (optional) true to confirm any warnings returned as exceptions.
    Returns:
      true if successful
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### removeVDChild

    boolean removeVDChild(Context context, String parentId, int childIdx, List<Attribute> attributes) throws Exception
    Remove child VD
    Parameters:
      `context` - `Context` object containing informations about client/session
      `parentId` - Id the the VD to be modified
      `childIdx` - Index of the child to remove.
      `attributes` - List of attributes
      - confirm - (optional) true to confirm any warnings returned as exceptions.
    Returns:
      true if successful
    Throws:
      `Exception`

  - ### setVDChildBindingVersions

    boolean setVDChildBindingVersions(Context context, String parentId, String childIdx, String versionLabel, List<Attribute> attributes) throws Exception
    Set binding version for a child components
    Parameters:
      `context` - `Context` object containing informations about client/session
      `parentId` - Id of the VD to modify.
      `childIdx` - Index of the child to set the binding version.
      `versionLabel` - Label of version to be bound (ie. "CURRENT", "1.0", "2.0")
      `attributes` - List of attributes
      - confirm - (optional) true to confirm any warnings returned as exceptions.
    Returns:
      true if successful
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### insertInheritedComponent

    String insertInheritedComponent(Context context, String srcVdId, String vdTemplateName, String inheritedComponentId, boolean overrideExistingComponent, List<Attribute> attributes) throws Exception
    Inserts an inherited component as child element based on a VD template
    Parameters:
      `context` - `Context` object containing informations about client/session
      `srcVdId` - Id of the VD to modify
      `vdTemplateName` - Virtual document template name
      `inheritedComponentId` - Id of the VD from which to inherit
      `overrideExistingComponent` - Boolean true to override.
      `attributes` - List of attributes
      - confirm - (optional) true to confirm any warnings returned as exceptions.
    Returns:
      String which contains a delimited ';' list of new objects if successful
    Throws:
      `Exception`
    Since:
      4.1.0

  - ### getDialogForOperation

    String getDialogForOperation(Context context, String parentId, String childId, String operation, List<Attribute> attributes) throws Exception
    Parameters:
      `context` - `Context` object containing informations about client/session
      `parentId` - Id of the parent
      `childId` - Id of the document for the operation
      `operation` - operation on the VD to be done
      `attributes` - List of attributes
    Returns:
      the dialog name to be used instead of default VD operation
    Throws:
      `Exception`
    Since:
      4.2.1

  - ### replaceVDChild

    boolean replaceVDChild(Context context, String vdocId, int childIndex, String newDocId, List<Attribute> attributes) throws Exception
    Replace child VD.
    Parameters:
      `context` - `Context` object containing informations about client/session.
      `vdocId` - Id the the VD to be modified.
      `childIndex` - Index of the child to replace.
      `newDocId` - The new document ID to be replaced with.
      `attributes` - List of attributes
      - confirm - (optional) true to confirm any warnings returned as exceptions.
    Returns:
      true if successful.
    Throws:
      `Exception`
    Since:
      16.3.0